#include <pluginlib/class_list_macros.h>
#include <ros/ros.h>

#include "mainNode/mainNode.h"

#include "car/camDataMsg.h"
#include "car/ccDataMsg.h"
#include "car/environmentDataMsg.h"
#include "car/logEnabledMsg.h"
#include "car/logStringMsg.h"
#include "car/rcEnabledMsg.h"
#include "car/stmDataMsg.h"
#include "car/ussDataMsg.h"

PLUGINLIB_EXPORT_CLASS(car::MainNode, nodelet::Nodelet);

namespace car
{
	MainNode::MainNode(ros::NodeHandle &nh, std::string &name) : nh(nh), name(name) {}
	MainNode::MainNode() {}
	MainNode::~MainNode() {}
	void MainNode::onInit()
	{
		NODELET_INFO("MainNode::onInit -- START");
		logEnabled = nh.advertise<logEnabledMsg>("logEnabled", 5);
	  environmentData = nh.subscribe("environmentData", 1, &MainNode::environmentDataCallback, this);
    std::cout << "MainNode &nh: " << &nh << "\n";


    		// CODE GOES HERE
		NODELET_INFO("MainNode::onInit -- END");
	}
  
  void MainNode::environmentDataCallback(const environmentDataMsg::ConstPtr& inMsg)
  {
    std::cout << "MainNode recived new environmentData data (" << inMsg->distance << ", " << inMsg->prevSpeed << ").\n";
  }
}
